import types;
import tango.util.collection.ArraySeq;

interface IProperty {
}

interface ISemanticModelBridge {
    char[] presentation();
}

interface ISimpleSemanticModelElement : ISemanticModelBridge {
    char[] type_info();
}

interface IDiagramElement {
    bool is_visible();
    IProperty[] get_properties();

    void accept(in IVisitor visitor);
}

interface IVisitor {
    void visit(in IGraphNode node);
    void visit(in IGraphEdge edge);
}

interface IGraphElement : IDiagramElement {
}

interface IGraphNode : IGraphElement {
}

interface IGraphEdge : IGraphElement {
}

interface IGraphConnector {
    Point point();
    IGraphElement element();
    IGraphEdge[] edges();
}
