module tk.gtk_support;

import tk.types;

static import gdk.Event;

ButtonAction gtk2tk_button_action(gdk.Event.EventType event_type) {
    switch (event_type) {
    case gdk.Event.EventType.BUTTON_PRESS:
        return ButtonAction.SINGLE_PRESS;
    case gdk.Event.EventType.DOUBLE_BUTTON_PRESS:
        return ButtonAction.DOUBLE_PRESS;
    case gdk.Event.EventType.TRIPLE_BUTTON_PRESS:
        return ButtonAction.TRIPLE_PRESS;
    case gdk.Event.EventType.BUTTON_RELEASE:
        return ButtonAction.RELEASE;
    default:
        assert(false);
    }
}

ButtonName gtk2tk_button_name(gdk.Event.guint button) {
    switch (button) {
    case 1:
        return ButtonName.LEFT;
    case 2:
        return ButtonName.MIDDLE;
    case 3:
        return ButtonName.RIGHT;
    case 4:
        return ButtonName.FOUR;
    case 5:
        return ButtonName.FIVE;
    default:
        assert(false);
    }
}

Mask gtk2tk_mask(gdk.Event.guint state) {
    Modifier[] modifiers;

    if (state & gdk.Event.GdkModifierType.SHIFT_MASK)   modifiers ~= Modifier.SHIFT;
    if (state & gdk.Event.GdkModifierType.CONTROL_MASK) modifiers ~= Modifier.CONTROL;
    if (state & gdk.Event.GdkModifierType.MOD1_MASK)    modifiers ~= Modifier.ALT;
    if (state & gdk.Event.GdkModifierType.MOD2_MASK)    modifiers ~= Modifier.META;
    if (state & gdk.Event.GdkModifierType.BUTTON1_MASK) modifiers ~= Modifier.BUTTON_LEFT;
    if (state & gdk.Event.GdkModifierType.BUTTON2_MASK) modifiers ~= Modifier.BUTTON_MIDDLE;
    if (state & gdk.Event.GdkModifierType.BUTTON3_MASK) modifiers ~= Modifier.BUTTON_RIGHT;
    if (state & gdk.Event.GdkModifierType.BUTTON4_MASK) modifiers ~= Modifier.BUTTON_FOUR;
    if (state & gdk.Event.GdkModifierType.BUTTON5_MASK) modifiers ~= Modifier.BUTTON_FIVE;

    return new Mask(modifiers);
}

ScrollDirection gtk2tk_direction(gdk.Event.ScrollDirection direction) {
    switch (direction) {
    case gdk.Event.ScrollDirection.UP:
        return ScrollDirection.UP;
    case gdk.Event.ScrollDirection.DOWN:
        return ScrollDirection.DOWN;
    case gdk.Event.ScrollDirection.LEFT:
        return ScrollDirection.LEFT;
    case gdk.Event.ScrollDirection.RIGHT:
        return ScrollDirection.RIGHT;
    default:
        assert(false);
    }
}
